/* 
Mikroekonometria 
Zajęcia 6 - Modele binarne
CC BY: Wiktor Budziński
*/

// Zadanie 1. – Rzut monetą

clear 
cls 
set seed 10311563
set obs 20

generate reszka = runiform() > 0.5
sum reszka

sum reszka
scalar N1 = r(sum)
scalar p = N1/20 // Nasz estymator
display p
scalar se = sqrt(N1*(20-N1)/20^3)
display se

// Statystyka z

scalar z = (p-0.5)/se
display z
display invnormal(0.975) // wartosc krytyczna

// Porownanie z "prawdziwym" modelem
scalar LL = N1*ln(N1/20) + (20-N1)*ln((20-N1)/20)
display LL
logit reszka 

// Niesymetryczna moneta

clear 
cls 
set seed 10311563
set obs 20

generate reszka = runiform() > 0.8
sum reszka

sum reszka
scalar N1 = r(sum)
scalar p = N1/20 // Nasz estymator
display p
scalar se = sqrt(N1*(20-N1)/20^3)
display se

// Statystyka z

scalar z = (p-0.5)/se
display z
display invnormal(0.025) // wartosc krytyczna

// Zadanie 2. – Zakup eko-jabłek

// 2.1. Wczytaj projekt me.apples.dta
use me_apples.dta, clear
des
sum

/* 2.2. Oszacuj model, w którym gotowość do zakupu dodatnich ilości eko-jabłek wyjaśniana jest przez:
Poziom edukacji respondenta
Cenę zwykłych jabłek
Cenę eko-jabłek
To, czy wybór dokonywany jest w sezonie
To czy respondent był mężczyzną
Dochód rodziny
Liczbę członków rodziny w każdej kategorii wiekowej */

gen eco = ecolbs > 0 // Tworzymy zmienną, która mówi nam czy ktoś w ogóle kupił eko-jabłka

sum eco

logit eco educ regprc ecoprc inseason male faminc numlt5 num5_17 num18_64 numgt64

// 2.3. Co dzieje się z modelem, jeśli dodatkowo uwzględnić wielkość rodziny?

logit eco educ regprc ecoprc inseason male faminc numlt5 num5_17 num18_64 numgt64 hhsize

// Analogicznie jak w regresji liniowej - ponieważ wielkość rodziny jest współliniowa ze zmiennymi:
// numlt5 num5_17 num18_64 numgt64, zostaje pominięta w modelu

// 2.4 Policz efekty krańcowe

logit eco educ regprc ecoprc inseason male faminc numlt5 num5_17 num18_64 numgt64
margins, dydx(*)
margins, eyex(*)
// 2.5. Porównaj oszacowany model z modelem probitowym

// Ocena dopasowania modelu
estat ic // Kryteria Informacyjne (im mniejsze tym lepiej)
estat classification // Tabela z klasyfikacją, nasz model przewiduje z około 67% skutecznością 
estat classification, cutoff(0.6)
// Ben-Akiva-Lerman's pseudo-R2
predict prob, pr // przewidujemy p-stwo
gen R2 = prob*eco + (1-prob)*(1-eco)
sum R2 // Średnia mówi nam jakie jest R2

hist R2

probit eco educ regprc ecoprc inseason male faminc numlt5 num5_17 num18_64 numgt64
estat ic 
estat classification
predict prob_probit, pr // przewidujemy p-stwo
gen R2_p = prob_probit*eco + (1-prob_probit)*(1-eco) 
sum R2_p // Średnia mówi nam jakie jest R2

// 2.6. Sprawdź poprawność  formy funkcyjnej analizowanego modelu logistycznego

// 2.6.1. Wykorzystaj polecenie wbudowane w STATĘ

logit eco educ regprc ecoprc inseason male faminc numlt5 num5_17 num18_64 numgt64
// Domyślna komenda staty
linktest // Patrzymy czy _hatsq jest istotne

// 2.6.2. Policz 'na piechotę'
logit eco educ regprc ecoprc inseason male faminc numlt5 num5_17 num18_64 numgt64
predict hat, xb // Liczymy wartości dopasowane z modelu
gen hatsq = hat^2
logit eco hat hatsq // Wyniki takie same jak policzone przez STATĘ
// Wyższy wielomian
gen hat3 = hat^3
logit eco hat hatsq hat3 // W tym przypadku nic nie zmienia

// 2.7. Sprawdź czy w analizowanym modelu występuje dająca się objaśnić heteroskedastyczność 

// Estymujemy probit z heteroskedastycznością
// Przykładowo modelujemy heteroskedastyczność przy użyciu 3 zmiennych (oczywiście można wykorzystać ich więcej)

hetprobit eco educ regprc ecoprc inseason male faminc numlt5 num5_17 num18_64 numgt64, het(male regprc ecoprc)

// STATA sama liczy nam test LR sprawdzający czy występuje heteroskedastyczność
// P-value < 0.05, więc należy odrzucić H0 - zignorowanie heteroskedastyczności istotnie pogarsza dopasowanie modelu do danych

margins, dydx(*)
